package com.jscape.inet.terminal.commands;

import com.jscape.inet.terminal.Terminal;

public class TBCCommand
        implements ControlCommand {

    public static final String CANONICAL_FORM = "\033[g";
    private static final TBCCommand INSTANCE = new TBCCommand();

    //----------------------------------------------------------------------------

    /**
     * Returns one and only one instance of this type.
     *
     * @return one and only one instance of this type.
     */
    public static TBCCommand getInstance() {
        return INSTANCE;
    }

    //----------------------------------------------------------------------------

    /**
     * Private constructor to prevent uncontrolled creation.
     */
    private TBCCommand() {
    }

    //----------------------------------------------------------------------------

    /**
     * Executes command giving parameters and <code>Terminal</code> object.
     *
     * @param params   array of <code>int</code> command parametrs.
     * @param terminal target <code>Terminal</code> object.
     */
    public void execute(int[] params, Terminal terminal) {
        if (params == null || params.length == 0) {
            clearTab(0, terminal);
        } else {
            for (int i = 0; i < params.length; ++i) {
                clearTab(params[i], terminal);
            }
        }
    }

    //----------------------------------------------------------------------------

    /**
     * Sends command to remote host.
     *
     * @param params   command parameters.
     * @param terminal target <code>Terminal</code> object to send command.
     */
    public void send(int[] params, Terminal terminal) {
        if (params == null || params.length == 0) {
            terminal.send(CANONICAL_FORM);
        } else {
            StringBuffer b = new StringBuffer("\033[");

            for (int i = 0; i < params.length; ++i) {
                b.append(params[i]);
                if (i < (params.length - 1)) {
                    b.append(';');
                }
            }

            b.append('g');
            terminal.send(b.toString());
        }
    }

    //----------------------------------------------------------------------------
    private void clearTab(int code, Terminal terminal) {
        switch (code) {
            case 0:
                terminal.getScreen().getCursor().getCell().setTabstop(false);
                break;
            case 3:
                terminal.getScreen().clearTabs();
                break;
            default:
                break;
        }
    }
}
